diff --git a/tests/TestSuite_vf_offload.py b/tests/TestSuite_vf_offload.py
index bd412100..93b28afd 100644
--- a/tests/TestSuite_vf_offload.py
+++ b/tests/TestSuite_vf_offload.py
@@ -185,10 +185,18 @@ class TestVfOffload(TestCase):
 
     def launch_testpmd(self, **kwargs):
         dcf_flag = kwargs.get("dcf_flag")
+        eal_param = self.eal_para if hasattr(self, "eal_para") else ""
+        eal_param += (
+            " --force-max-simd-bitwidth=%d " % self.specific_bitwidth
+            if hasattr(self, "specific_bitwidth")
+            and not "force-max-simd-bitwidth" in eal_param
+            else ""
+        )
         param = kwargs.get("param") if kwargs.get("param") else ""
         if dcf_flag == "enable":
             self.vm0_testpmd.start_testpmd(
                 VM_CORES_MASK,
+                eal_param=eal_param,
                 param=param,
                 ports=[self.vf0_guest_pci, self.vf1_guest_pci],
                 port_options={
@@ -197,7 +205,9 @@ class TestVfOffload(TestCase):
                 },
             )
         else:
-            self.vm0_testpmd.start_testpmd(VM_CORES_MASK, param=param)
+            self.vm0_testpmd.start_testpmd(
+                VM_CORES_MASK, eal_param=eal_param, param=param
+            )
 
     def checksum_enablehw(self, port, dut):
         dut.send_expect("port stop all", "testpmd>")
@@ -812,6 +822,106 @@ class TestVfOffload(TestCase):
 
         self.verify(len(result) == 0, ",".join(list(result.values())))
 
+    def test_checksum_offload_enable_scalar(self):
+        self.specific_bitwidth = 64
+        self.test_checksum_offload_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_enable_sse(self):
+        self.specific_bitwidth = 128
+        self.test_checksum_offload_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_enable_avx2(self):
+        self.specific_bitwidth = 256
+        self.test_checksum_offload_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_enable_avx512(self):
+        self.specific_bitwidth = 512
+        self.test_checksum_offload_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_vlan_enable_scalar(self):
+        self.specific_bitwidth = 64
+        self.test_checksum_offload_vlan_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_vlan_enable_sse(self):
+        self.specific_bitwidth = 128
+        self.test_checksum_offload_vlan_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_vlan_enable_avx2(self):
+        self.specific_bitwidth = 256
+        self.test_checksum_offload_vlan_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_vlan_enable_avx512(self):
+        self.specific_bitwidth = 512
+        self.test_checksum_offload_vlan_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_tunnel_enable_scalar(self):
+        self.specific_bitwidth = 64
+        self.test_checksum_offload_tunnel_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_tunnel_enable_sse(self):
+        self.specific_bitwidth = 128
+        self.test_checksum_offload_tunnel_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_tunnel_enable_avx2(self):
+        self.specific_bitwidth = 256
+        self.test_checksum_offload_tunnel_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_tunnel_enable_avx512(self):
+        self.specific_bitwidth = 512
+        self.test_checksum_offload_tunnel_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_vlan_tunnel_enable_scalar(self):
+        self.specific_bitwidth = 64
+        self.test_checksum_offload_vlan_tunnel_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_vlan_tunnel_enable_sse(self):
+        self.specific_bitwidth = 128
+        self.test_checksum_offload_vlan_tunnel_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_vlan_tunnel_enable_avx2(self):
+        self.specific_bitwidth = 256
+        self.test_checksum_offload_vlan_tunnel_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_vlan_tunnel_enable_avx512(self):
+        self.specific_bitwidth = 512
+        self.test_checksum_offload_vlan_tunnel_enable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_disable_scalar(self):
+        self.specific_bitwidth = 64
+        self.test_checksum_offload_disable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_disable_sse(self):
+        self.specific_bitwidth = 128
+        self.test_checksum_offload_disable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_disable_avx2(self):
+        self.specific_bitwidth = 256
+        self.test_checksum_offload_disable()
+        del self.specific_bitwidth
+
+    def test_checksum_offload_disable_avx512(self):
+        self.specific_bitwidth = 512
+        self.test_checksum_offload_disable()
+        del self.specific_bitwidth
+
     def tcpdump_start_sniffing(self, ifaces=[]):
         """
         Start tcpdump in the background to sniff the tester interface where
@@ -1158,6 +1268,46 @@ class TestVfOffload(TestCase):
             outer_pkts=pkts_outer,
         )
 
+    def test_tso_scalar(self):
+        self.specific_bitwidth = 64
+        self.test_tso()
+        del self.specific_bitwidth
+
+    def test_tso_sse(self):
+        self.specific_bitwidth = 128
+        self.test_tso()
+        del self.specific_bitwidth
+
+    def test_tso_avx2(self):
+        self.specific_bitwidth = 256
+        self.test_tso()
+        del self.specific_bitwidth
+
+    def test_tso_avx512(self):
+        self.specific_bitwidth = 512
+        self.test_tso()
+        del self.specific_bitwidth
+
+    def test_tso_tunnel_scalar(self):
+        self.specific_bitwidth = 64
+        self.test_tso_tunnel()
+        del self.specific_bitwidth
+
+    def test_tso_sse(self):
+        self.specific_bitwidth = 128
+        self.test_tso_tunnel()
+        del self.specific_bitwidth
+
+    def test_tso_avx2(self):
+        self.specific_bitwidth = 256
+        self.test_tso_tunnel()
+        del self.specific_bitwidth
+
+    def test_tso_avx512(self):
+        self.specific_bitwidth = 512
+        self.test_tso_tunnel()
+        del self.specific_bitwidth
+
     def tear_down(self):
         self.vm0_testpmd.execute_cmd("quit", "# ")
         self.dut.send_expect(